' Last touched: June 18, 2002

' Description: Script for downloading a file from URL to the given directory on a NW server
' Created: Dec 2000 - Nov 2001
' Usage:  NSNINIT (run just once for starting the scripting machine)
' 	  NSN GETFTP [ftp://]ftpserver/[path/]filename local_volume:[path_to_save_directory] [/REN]
'         (using the "*" wildcard in the requested filename is allowed)
'
'
Sub Main
'
'***** Get arguments and convert them into script variables *****
'
     If (ArgumentCount < 3) Then
        Print
   	Print "Insufficient number of parameters"
        Print
	Exit Sub
     End If


        FTPSrvr=""				 	'Initial value - empty string
	FTPPath=""				 	'Initial value - empty string
	URL = Arguments(2)			 	'First parameter is URL
	Path = Arguments(3) 			 	'Second parameter - path for file to save
'
	If (ArgumentCount >= 4) Then
		RenameFile = UCase(Left(Arguments(4), 4))="/REN"	
							'Non-mandatory third parameter /REN
							'(Downloaded files will be saved as "DFileX"
							'where X is a sequence number of downloaded file) 
	End If
'
	URLLEN = len(URL)				'Give us lenghth of the URL string
	If (((Left(URL, 6)) = "ftp://") OR ((Left(URL, 6)) = "FTP://")) Then
	  URLLEN = URLLEN - 6
	  URL = Right(URL, URLLEN)			'Cut out the ftp:// (6 chrs from left)
	End If

        URLparts = split(URL,"/")		 	'Split URL according to "/" char
	FTPSrvr=URLparts(0)			 	'URLparts(0) is the FTP server name
 	FileName=URLparts(ubound(URLparts))		'Last part of URL is filename
	Path = Replace(Path, "/", "\")			'Replace eventual chars "/" by "\"
	If (Right(Path, 1) <> "\") Then 
	 Path = Path + "\"
	End If



	FNLen = Len(FileName)
        FNparts = split(FileName,".")			'Split filename according to "." char
	NumFNparts = ubound(FNparts)
	NEA = 0						'Not (Extension = Asterisk)
	If (NumFNparts > 0) Then
	     ExtPresent = 1				'Extension is present	
	     Ext = FNparts(NumFNparts)			'Separation of the name extension
	     If (Ext = "*") then NEA = 0 Else NEA = 1
	     ExtLen = Len(Ext)				'Length of the extension - string behind the last dot
	     BName = Left (Filename,(FNLen-ExtLen-1))	'Separation of the base name
	Else 
	     BName = FileName				'File has no extension
	     ExtPresent = 0				'Extension is not present
	End If
	BLen = Len(BName)				'Length of base name (without extension)

	IF (ubound(URLparts) >= 2) then
	  for i = 1 to (ubound(URLparts)-1) step 1
 	    FTPPath=FTPPath + "/" + URLparts(i)		'Reconstruct FTP path 
          next i					' without servername and filename
	Else 
	  FTPPath="/"
	End If
'
'
    On Error Resume Next				'Enables our own error handling,
							' e.g. disables the NSN error windows
'
	PRINT
	set stream1 = createobject("ucx:fio")
	set stream2 = createobject("scripting.FileSystemObject")
	set LogFile = stream1.open("SYS:\ETC\GETFTP.LOG", FIO_CREATE_APPEND_WRITE)
	LogFile.Close
'
	Set LogFile =  stream2.GetFile("SYS:\ETC\GETFTP.LOG")
	LogFSize = LogFile.Size				'To check if the log size is lower 100K
	if (LogFSize > 102400) Then
		If stream2.FileExists("SYS:\ETC\GETFTP.000") Then
			Set OldLogFile =  stream2.GetFile("SYS:\ETC\GETFTP.000")
			OldLogFile.Delete(True)			'Delete old log backup
		End If
		LogFile.Name = "GETFTP.000"		'Rename current logfile into backup
		PRINT ("GETFTP.LOG file size exceeded 100KB. Restarting log.")
		WriteLog("GETFTP.LOG file size exceeded 100KB. Restarting log.")
	End If
'
	TimeLine="*** GETFTP Launched " & CStr(DATE) & " at " & CStr(TIME)
	WriteLog("")
	WriteLog(Timeline)
'
'***** Read the ftp login ID from the SYS:\ETC\FTPLOGIN.ID file ***** 
'
	set IdFile = stream2.opentextfile("SYS:\ETC\FTPLOGIN.ID")
'
	    If (Err.Number <> 0) Then 
		Print
	        Print("*** GETFTP ERROR: Unable to open the login ID file (SYS:\ETC\FTPLOGIN.ID)"0
		WriteLog("*** GETFTP ERROR: Unable to open the login ID file (SYS:\ETC\FTPLOGIN.ID)")
		Print
	        CloseLog
		Exit Sub
	    End If
'
        Value = IdFile.Readline
        LoginID =  Value
        Value = IdFile.Readline
        LoginPwd =  Value
    IdFile.Close

    PtChk = Path
    If not (stream2.FolderExists(PtChk)) Then
        Print
	Print
	Print("*** GETFTP ERROR: Target directory to save file(s) does not exist")
	WriteLog("*** GETFTP ERROR: Target directory to save file(s) does not exist")
	CloseLog
	Exit Sub
    End If

'
'***** Begin the ftp operations ***** 
'
	set ftpmgr = createobject ("ucx:ftpfilemgr")
	ftpmgr.server = FTPSrvr
	ftpmgr.timeout = 20
	IF not(ftpmgr.login (LoginID, LoginPwd)) then 
		WriteLog("*** GETFTP ERROR: Unable to login to ftp server")
		CloseLog
		Exit Sub
	Else
		WriteLog("Logged in to "& FTPSrvr)
	End IF
	Print
	set currentDir = ftpmgr.currentDir
	Print ("*** Changing current directory to "&FTPPath)
	If not(ftpmgr.changeDir(FTPPath)) then 
		WriteLog("Unable to change directory to "&FTPPath)
		CloseLog
		Exit Sub
	Else
	WriteLog("Changed dir to "&FTPPath)
	End IF

	set currentDir = ftpmgr.currentDir
	Print ("*** Changed current directory to "&currentDir.Name)
	set entries = currentDir.getchildren()
	entries.reset 
'
	NumDone=1					'Counter for number of downloaded files
	while (entries.hasmoreelements)
        set Entry = entries.next			'Repeat this for all entries in the current directory
	FTG = (Entry.Name)	
	PRINT ("*** Checking "&FTG)
	If (Entry.directory) then IsFile = 0 Else IsFile = 1
	
        FTGprts = split(FTG," ")			'Split FileToGet to get rid of the information
	NumFTGprts = ubound(FTGprts)			' preceding the last space in the dir listing
	FTG =  FTGprts(NumFTGprts)			' (obtaining actual FileToGet name)

	FTGLen = Len(FTG)
        FTGparts = split(FTG,".")			'Split FileToGet name according to "."
	NumFTGparts = ubound(FTGparts)			' to separate it's extension (part behind the last dot)
	If (NumFNparts > 0) Then
	     ExtPr = 1					'Extension is present	 
	     FTGExt = FTGparts(NumFTGparts)		'Separation of the name extension
	     FTGELen = Len(FTGExt)			'Length of the extension - string behind the last dot
	     BFTG = Left(FTG,(FTGLen - FTGELen - 1))	'Separation of the base name
	Else 
	     ExtPr = 0					'Extension is not present
	     BFTG = FTG					'File has no extension
	End If
	BFTGLen = Len(BFTG)

'***** Check if name and extension agree with required name *****

	If (IsFile = 1) Then
		GetIt = 0
		SkipMtchExt = ExtPresent * ExtPr + NEA	'Both extensions not present or ext = asterisk
		If (SkipMtchExt = 0) then
			If (Match(BName, BFTG) = 0) then GetIt = 1
		Else
			If ((Match(BName, BFTG) = 0) and (Match(EXT,FTGExt) = 0)) then GetIt = 1
		End If
		If (GetIt = 1) then

'***** Perform the ftp transfer ***** 

			Print("*** Now downloading: "&FTG)
			If ((30-FTGLEN)>0) Then 
				Shim = 30 - FTGLEN
			Else
				Shim = 0
			End IF
			Print Shim
			DLine = "Downloading: " + FTG + String(Shim, " ") + "..."
			SavePath = Path
			If not (RenameFile) then
				SavePath = SavePath+FTG			 	'Add filename to the save path
				Renamed = ""
			Else
				SavePath = SavePath + "DFile" + CStr(NumDone) 	'Add filename to the save path
				Renamed = "  -> Saved as  DFile" + CStr(NumDone)'Rename remark for logfile
				NumDone = NumDone + 1				'Increase NumDone
			End If

			ftpmgr.BinMode = True
			If entries.Get (FTG, SavePath) Then
				DLine = Dline + " OK" + Renamed
				WriteLog(DLine)
			Else
				DLine = Dline + "FAIL"
				WriteLog(DLine)
			End IF
		End If
	End If
	wend 
	ftpmgr.logout()
'
CloseLog
'
End Sub
'
'
'
'
Function Match(Req, Act)
'***** Function to find out if requested name matches the actual name *****
'***** If strings agree, Match = 0 *****
'
'
Req=UCase(Req)						'Convert Req to uppercase for comparing
Act=UCase(Act)						'Convert Act to uppercase for comparing

If (Req = "*") then
	Match = 0
	Exit Sub
End If

qry = Left(Req, 1)
AL = (Len(Req) -1)

If (qry = "*") then
	Aux = Right(Req, AL)
	ActPart = Right(Act, AL)
	If (Aux = ActPart) then Match = 0 else Match = 1
	Exit Sub
Else
	qry = Right(Req, 1)
	If (qry = "*") then
		Aux = Left(Req, AL)
		ActPart = Left(Act, AL)
		If (Aux = ActPart) then Match = 0 else Match = 1  
		Exit Sub
	Else
		If (Req = Act) then Match = 0 else Match = 1 
		Exit Sub
	End If
End If

End Sub
'
'
'
'
Sub WriteLog(WLine)
'***** Procedure to write given line to the log file *****
'
'
	set LF = createobject("ucx:fio")
	set LogFile = LF.open("SYS:\ETC\GETFTP.LOG", FIO_CREATE_APPEND_WRITE)
	LogFile.Writeline(WLine)
	LogFile.Close
End Sub
'
'
'
'
Sub CloseLog()
'***** Procedure to write end line to the log file *****
	TimeLine="*** GETFTP Finished " & CStr(DATE) & " at " & CStr(TIME)
	WriteLog(TimeLine)
End Sub